/* 			Copyright (c) 1988 by Caldera Corporation						*/
	
/*			PO box 3252, Ann Arbor, MI 48106   (313) 996-9059				*/

/*		File: 		windows.h
		Compilers: 	LightSpeedC 3.0, Aztec C 3.0							*/

/*		Abstract:															*/
/*			high level and code segment 1 routines for windows				*/

/*		History:															*/
/*			2/10/89 1.0d - released final 1.0 version 						*/


#define		APPLEMENU		5001    		/* menu resource ID constants 	*/
#define			appleABOUT		1
#define		FILEMENU		5002
#define			fileNEW			1
#define			fileQUIT		10
#define		EDITMENU		5003
#define			editUNDO		1
#define			editCUT			3
#define			editCOPY		4
#define			editPASTE		5
#define			editSELECTALL	7
#define		OPTIONMENU		5004
#define			ADD_ITEM		1
#define			NEW_WINDOW		2
#define			NEW_BUTTON		4
#define			NEW_CHECKBOX	5
#define			NEW_RADIOBUTTON	6
#define			DISP_DIALOG		8
#define			DISP_MODELESS	9
#define			DISP_ALERT		10

#define		MAXMENUS		4

#define		RESID_BASE		5000

#define		MAXWINDOWS		10		/* for global window record array dim	*/

extern MenuHandle	menuHdls[MAXMENUS+1];	/* external global variables	*/
extern WindowRecord	wRecs[MAXWINDOWS];
extern WindowPtr	wPtrs[MAXWINDOWS];

extern Boolean		done;      						/*	quit program flag	*/
extern EventRecord	myEvent;   						/*	app event record	*/

extern Rect			dragRect;						/* drag window bounds	*/
extern Rect			limitRect;						/* resize window bounds	*/

void 		Init_all( void );
void 		Set_up_menus( void );

OSErr		DoAppleCmds( int );
OSErr		DoFileCmds( int );
OSErr		DoEditCmds( int );
OSErr		DoOptionCmds( int );
OSErr 		Dispatch ( long	);

void 		DoKey( long, int );
OSErr	 	DoUpdate( WindowPtr );
OSErr 		DoActivate ( WindowPtr );
OSErr 		DoMouseDown ( Point );

void		main ( void );
void		DeAllocWindow( WindowPtr );
WindowPtr	AllocWindow( void );
Boolean 	HasGrow( WindowPtr );
void	 	SetGrow( WindowPtr, Boolean );
pascal void	MyTracker ( ControlHandle, int );

